#include <SPI.h>
#include "SdFat.h"
#include <Arduino.h>
#include <Wire.h>
#include "LiquidCrystal_PCF8574.h"

#define TAPE_OUT      1                                                         // Tape out pin
#define TURBO         0                                                         // Turbo in pin

#define CPU_HZ        48000000                                                  // CPU clock frequency
#define TIMER_PRESCALER_DIV 1024                                                // Prescaler divisor

#define SD_FAT_TYPE   3                                                         // SD card FAT type
#define SD_CS_PIN     6                                                         // SD card CS pin

#define alxBTN_UP     2                                                         // Button up
#define alxBTN_DN     3                                                         // Button down  
#define KEYB_DELAY    16384                                                     // Delay per keypress in CPU cycles

#define KEYB_UP       1                                                         // Keyboard state UP
#define KEYB_DN       2                                                         // Keyboard state DOWN
#define KEYB_EN       3                                                         // Keyboard state "enter"
#define KEY1_FLG      0xfe                                                      // Flag for key1 released
#define KEY2_FLG      0xfd                                                      // Flag for key2 released
#define KEY1_FLP      0x01                                                      // Flag for key1 pressed
#define KEY2_FLP      0x02                                                      // Flag for key2 pressed
#define KEY_SPCL      0x07                                                      // Flag for both keys pressed
#define ICN_FLDR      0x02                                                      // Folder icon
#define ICN_FILE      0x01                                                      // File icon

#define MAX_FILES     255                                                       // Max number of files per folder
#define MAX_NAMELEN   20                                                        // Max lenghth of file/folder name
#define MAX_PATH      1024                                                      // Max path length

#define LCD_CHARS     20                                                        // Characters per line on LCD display
#define LCD_LINES     4                                                         // Lines on LCD  
#define LCD_BACKLT    255                                                       // Level of backlight for LCD
#define LCD_ADDRESS   0x27                                                      // LCD I2C slave address
#define LCD_TICKS     18                                                        // Ticks per loaded slider

#define DATA_BLOCK    16384                                                     // Data block for holding tape data

#define SIZE_HALF     8192                                                      // Half of the buffer
#define UPPER_THRESH  8400                                                      // Threshold above upper half
#define LOWER_THRESH  10                                                        // Threshold above beginning

#define SERIAL_DEBUG  0                                                         // Serial debug, set to 1 if debug is needed

const byte safldr[] =                                                           // Folder icon
{ 
  0b00000,                                                                      // .....
  0b00010,                                                                      // ...X.
  0b11111,                                                                      // XXXXX
  0b00010,                                                                      // ...X.
  0b00000,                                                                      // .....
  0b00010,                                                                      // ...X.
  0b11111,                                                                      // XXXXX
  0b00010                                                                       // ...X.
};
const byte safile[] =                                                           // File icon
{   
  0b00000,                                                                      // .....
  0b00000,                                                                      // .....
  0b00100,                                                                      // ..X..  
  0b00010,                                                                      // ...X.
  0b11111,                                                                      // XXXXX
  0b00010,                                                                      // ...X.
  0b00100,                                                                      // ..X..
  0b00000                                                                       // .....
};
